searchNodes=[{"doc":"Behaviour that should be implemented for handling authentication and communcication over a Fedecks Websocket. Requires a keyword-list configuration value keyed by the OTP app name, returned by the otp_app/0 callback and the module name, which returns a keyword list with the keys: secret used to encode and sign an authentication token salt also used to encode and sign and authentication token (optional) token_refresh_millis - how often the token is refreshed and sent to the client, in milliseconds. The default is 3 hours token_expiry_secs - how many seconds before a token expires. The default is 4 weeks. For example, an handle called MyApp.MyHandler with an application name :my_app may have the following configuration set config :my_app , MyAppHandler , secret : &quot;ULO1b5eiGSPNcrnAvnIXGy7JhH0WorbLkVq/pT10V/0/Hq7Dw66A5XIbZT0X6zq4&quot; , salt : &quot;b/BuhKLXOIqYM8sD53XnT51gwiBHmBpv+eM5I6HrvERTleoIq0EHYi76aNo+PP5E&quot; , token_refresh_millis : :timer . minutes ( 30 ) , token_expiry_secs : 360","ref":"FedecksServer.FedecksHandler.html","title":"FedecksServer.FedecksHandler","type":"behaviour"},{"doc":"Use the fedecks information supplied at login authenticate the user. Only called if there is no fedecks-token supplied, so is likely to be an initial registration, a re-registration (perhaps to associate the device with a new user), or a re-registration due to an expired token which can occur if a device has not connected for a few days. Will be a map with string keys. The key &quot;fedecks-device-id&quot; will present which you can use to associate the device with a user (should you wish).","ref":"FedecksServer.FedecksHandler.html#c:authenticate?/1","title":"FedecksServer.FedecksHandler.authenticate?/1","type":"callback"},{"doc":"Called when a new connection is established, with the Fedecks box device_id.","ref":"FedecksServer.FedecksHandler.html#c:connection_established/1","title":"FedecksServer.FedecksHandler.connection_established/1","type":"callback"},{"doc":"Optional. Handles incoming message, which has been encoded by the Fedecks client as an Erlang binary term that is safe to decode. Binary messages which are not safe Erlang terms can be handled by handle_raw_in/2 . Text messages are ignored. For no reply, return ':ok' To reply, return {:reply, &quot;some message&quot;} . The message will be conded as an Erlang binary term. As the Fedecks client will used safe decoding avoid atoms (or structs) that are not present on the client. It is safer to stick to maps, rather than structs, and strings rather than atoms (eg for map keys). To terminate the connection, return {:stop, reason}","ref":"FedecksServer.FedecksHandler.html#c:handle_in/2","title":"FedecksServer.FedecksHandler.handle_in/2","type":"callback"},{"doc":"Called when the connection process has received a message (to its process mailbox). Internal Fedecks messages, ie :refresh_token have been filtered out. The info message and a map of user data is sent. Return :ok for now action {:push, message} to send a message down the socket, as an erlang binary term {:stop, reason} to","ref":"FedecksServer.FedecksHandler.html#c:handle_info/2","title":"FedecksServer.FedecksHandler.handle_info/2","type":"callback"},{"doc":"Optional. Handles incoming messages raw binary messages. For no reply, return :ok To reply, return {:reply, message} . The message will be sent to the client as a binary. To terminate the connection, return {:stop, reason}","ref":"FedecksServer.FedecksHandler.html#c:handle_raw_in/2","title":"FedecksServer.FedecksHandler.handle_raw_in/2","type":"callback"},{"doc":"The name of the OTP app used to get the configuration details.","ref":"FedecksServer.FedecksHandler.html#c:otp_app/0","title":"FedecksServer.FedecksHandler.otp_app/0","type":"callback"},{"doc":"Optionally called when an error occurs, such as receiving an invalid message, authentication failure, or other","ref":"FedecksServer.FedecksHandler.html#c:socket_error/3","title":"FedecksServer.FedecksHandler.socket_error/3","type":"callback"},{"doc":"","ref":"FedecksServer.FedecksHandler.html#t:error_type/0","title":"FedecksServer.FedecksHandler.error_type/0","type":"type"},{"doc":"","ref":"FedecksServer.FedecksHandler.html#t:opcode/0","title":"FedecksServer.FedecksHandler.opcode/0","type":"type"},{"doc":"Sets up a Phoenix.Socket.Transport that connects to a Fedecks Websocket client Usage: In your endpoint call the macro fedecks_socket/2 eg defmodule MyApp.Endpoint use Phoenix.Endpoint , otp_app : :my_app import FedecksServer.Socket , only : [ fedecks_socket : 1 ] fedecks_socket ( MyApp.SocketHandler ) end","ref":"FedecksServer.Socket.html","title":"FedecksServer.Socket","type":"module"},{"doc":"Included in your Endpoint. Note: path defaults to &quot;/fedecks&quot;. The actual endpoint path will have &quot;/websocket&quot; appended by Phoenix, so the default is really &quot;/fedecks/websocket&quot;. The handler should be a module that implements FedecksServer.FedecksHandler .","ref":"FedecksServer.Socket.html#fedecks_socket/2","title":"FedecksServer.Socket.fedecks_socket/2","type":"macro"},{"doc":"Provides a websocket for a Phoenix application, for establishing communications with a Fedecks Client , probably running on a Nerves Device.","ref":"readme.html","title":"Fedecks Server","type":"extras"},{"doc":"Add to deps { :fedecks_server , &quot;~&gt; 0.1&quot; }","ref":"readme.html#installation","title":"Fedecks Server - Installation","type":"extras"},{"doc":"Step 1 - Implement a handler Implement a FedecksServer.FedecksHandler to handle connecting and upstream messages. eg defmodule MyAppWeb.MyFedecksHandler do @behaviour FedecksHandler @impl FedecksHandler def authenticate ( %{ &quot;username&quot; =&gt; username , &quot;password&quot; =&gt; password , &quot;fedecks-device-id&quot; =&gt; device_id } ) do MyApp.MyAuth . device_auth ( username , password , device_id ) end def authenticate? ( _ ) , do : false @impl FedecksHandler def otp_app , do : :my_app end Other optional callbacks you can implement include FedecksServer.FedecksHandler.handle_in/2 for handling incoming messages as Erlang terms FedecksServer.FedecksHandler.handle_raw_in/2 for handling incoming raw binary messsages FedecksServer.FedecksHandler.connection_established/1 - this will be called every time a connection is established with a client. You can use this for things like tracking with Phoenix.Presence or subscribing to a Pub Sub topic with your device id, to allow messages to be sent to your device. FedecksServer.FedecksHandler.handle_info/2 - handle internal messages sent to your socket's process inbox. If you have subscribed to a Pub Sub topic with your device id, then this is how you would initiate sending messages to your device. FedecksServer.FedecksHandler.socket_error/3 - any errors that have happened, such as receiving an invalid message or authentication failures, would be reported here. Step 2 - Add configuration In your config you must add configuration for your handler. eg import Config config :my_app , MyAppWeb.MyFedecksHandler , salt : System . fetch_env! ( &quot;FEDECKS_SALT&quot; ) , secret : System . fetch_env! ( &quot;FEDECKS_SECRET&quot; ) The salt and secret are used to encode the authentication token that is used for restablishing connections without logging in. You can generate them, for instance, with mix phx.gen.secret . Additional optional configuration options are token_refresh_millis : the number of milliseconds between a refreshed token being sent to the client. Defaults to 3 hours. token_expiry_secs : the number of seconds after which a token will expire. Currently set to 4 weeks, which is arguably over long. Step 3 - Add to the endpoint Add the endpoint with the macro FedecksServer.Socket.fedecks_socket/2 . Eg defmodule MyAppWeb.Endpoint use Phoenix.Endpoint , otp_app : :my_app import FedecksServer.Socket , only : [ fedecks_socket : 1 ] fedecks_socket ( MyApp.SocketHandler ) end The socket path defaults to &quot;fedecks&quot; but can be optionally provided to the FedecksServer.Socket.fedecks_socket/2 . Note that the actual path will have &quot;/websocket&quot; appended as Phoenix.Socket.Transport also supports long polling and needs to know which the client wants: the default path is actually &quot;fedecks/websocket&quot;. Step 4 - Implement the rest of the owl the client side Use Fedecks Client on your Nerves device to communicate with the server.","ref":"readme.html#using","title":"Fedecks Server - Using","type":"extras"},{"doc":"Phoenix 1.7 now uses WebSock which is analagous to Plug for websockets, which allows for more flexible approach to adding a Phoenix.Socket.Transport to your endpoint. I want to find some time to explore that approach.","ref":"readme.html#potential-roadmap","title":"Fedecks Server - Potential roadmap","type":"extras"},{"doc":"","ref":"changelog.html","title":"Change Log","type":"extras"},{"doc":"Initial version","ref":"changelog.html#v0-1-0","title":"Change Log - v0.1.0","type":"extras"},{"doc":"Documentation update","ref":"changelog.html#v0-1-1","title":"Change Log - v0.1.1","type":"extras"}]